package datastructures;

public class Belief {
    private final String label; // immutable
    private final Value value; // mutable

    public Belief(String label, Value value) {
        this.label = label;
        this.value = value;
    }

    public String getLabel() {
        return label;
    }

    public Value getValue() {
        return value;
    }

    @Override
    public boolean equals(Object other) {
        if (!(other instanceof Belief)) {
            return false;
        }
        return ((Belief) other).value.equals(value);
    }
}
