package test;

import static org.junit.Assert.*;

import java.util.LinkedList;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import exceptions.QueryFormattingException;

import queries.QueryStringParser;
import queries.QueryToken;
import queries.QueryToken.UnknownToken;

public class QueryTreeNodeTests extends TestBase {
    private UnknownToken token;

    @Override
    @Before
    public void setUp() throws Exception {
        token = new QueryToken.UnknownToken("a(b(c))");
    }

    @Override
    @After
    public void tearDown() throws Exception {
    }

    @Test
    public void splitLeftParentheses() {
        LinkedList<QueryToken> result = token.split("(");
        assertEquals(result.size(), 5);
        assertEquals(result.pop().toString(), "a");
        assertEquals(result.pop().toString(), "(");
        assertEquals(result.pop().toString(), "b");
        assertEquals(result.pop().toString(), "(");
        assertEquals(result.pop().toString(), "c))");
    }

    @Test
    public void splitRightParentheses() {
        LinkedList<QueryToken> result = token.split(")");
        assertEquals(result.size(), 3);
        assertEquals(result.pop().toString(), "a(b(c");
        assertEquals(result.pop().toString(), ")");
        assertEquals(result.pop().toString(), ")");
    }

    @Test
    public void parseCriteriaString() throws QueryFormattingException {
        QueryToken parsed;
        parsed = QueryStringParser.parseCriteriaString("a AND b");
        assertNotNull(parsed);
        parsed = QueryStringParser
                .parseCriteriaString("a AND b AND (c OR d) AND(e OR f OR(g AND h AND i)) AND j");
        assertNotNull(parsed);

        // TODO more coverage
    }
}
