package test;

import static org.junit.Assert.*;

import org.junit.Test;


import exceptions.IllegalRevisionException;
import exceptions.QueryFormattingException;
import exceptions.UnknownBeliefLabelException;

public class RevisionTests extends TestBase {
    // TODO add more coverage for this test case?
    @Test
    public void add() throws QueryFormattingException, UnknownBeliefLabelException, IllegalRevisionException {
        // only want to make sure it doesn't throw any exceptions
        cumulative.add("a");
        cumulative.add("b");
        assertTrue(value("a", 0, 0.5));
        assertTrue(value("a AND b", 0, 0.25));

        cumulative.revise("a >= (0, 0.6)");

        assertTrue(value("a OR b", 0, 0.8));
        assertTrue(value("-a AND -b", 0, 0.2));
    }

    @Test
    public void alternateRevisionSyntax() throws QueryFormattingException, UnknownBeliefLabelException,
            IllegalRevisionException {
        cumulative.add("a");
        cumulative.add("b");
        cumulative.add("c");

        cumulative.revise("a <= c AND b");
        cumulative.revise("a >= c AND b");
        cumulative.revise("a = c AND b");
        cumulative.revise("a AND c >= b");
    }
}
