package test;

import static org.junit.Assert.*;

import org.junit.Test;


import exceptions.IllegalRevisionException;
import exceptions.QueryFormattingException;
import exceptions.UnknownBeliefLabelException;

/**
 * This is a general-purpose class that you can use to write your own tests and play with the Cumulative
 * Measure query and revision library.
 * 
 * Each function runs a single test, and all variables are re-initialized for each test (so you don't have to
 * worry about the tests interfering with each other's data)
 * 
 */
public class SandboxTests extends TestBase {
    @Test
    public void template() throws QueryFormattingException, UnknownBeliefLabelException,
            IllegalRevisionException {
        // use this function as a template to modify or to copy & paste code into your own tests
        cumulative.add("a");
        cumulative.add("b");
        assertTrue(value("a", 0, 0.5));
        assertTrue(value("a AND b", 0, 0.25));
        assertTrue(value("-a AND -b", 0, 0.25));

        cumulative.revise("a >= (0, 0.6)");

        assertTrue(value("a", 0, 0.6));
        assertTrue(value("a AND b", 0, 0.3));
        assertTrue(value("-a AND -b", 0, 0.2));
        assertTrue(value("a OR b", 0, 0.8));
    }

    @Test
    public void myTest1() throws QueryFormattingException, UnknownBeliefLabelException,
            IllegalRevisionException {
        cumulative.add("a");
        cumulative.add("b");
    }

    @Test
    public void myTest2() throws QueryFormattingException, UnknownBeliefLabelException,
            IllegalRevisionException {
        cumulative.add("a");
        cumulative.add("b");
    }
}
