package test;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

import queries.TokenList;
import queries.TokenListNode;
import queries.QueryToken.UnknownToken;

public class TokenListTests extends TestBase {
    private TokenList list;

    @Override
    @Before
    public void setUp() throws Exception {
        list = new TokenList();
    }

    @Test
    public void toStringTest() {
        list.add(new UnknownToken("a(b(c"));
        list.add(new UnknownToken("OR"));
        list.add(new UnknownToken("d))"));
        // just verify that it doesn't throw anything or spin forever
        list.toString();
    }

    @Test
    public void add() {
        list.add(new UnknownToken("a(b(c"));
        list.add(new UnknownToken("OR"));
        list.add(new UnknownToken("d))"));
    }

    @Test
    public void split() {
        TokenListNode node = new TokenListNode(new UnknownToken("a(b(c))"));
        TokenListNode splitTokens = node.split("(");
        assertEquals(splitTokens.getToken().toString(), "a");
        splitTokens = splitTokens.getNext();
        assertEquals(splitTokens.getToken().toString(), "(");
        splitTokens = splitTokens.getNext();
        assertEquals(splitTokens.getToken().toString(), "b");
        splitTokens = splitTokens.getNext();
        assertEquals(splitTokens.getToken().toString(), "(");
        splitTokens = splitTokens.getNext();
        assertEquals(splitTokens.getToken().toString(), "c))");
        assertNull(splitTokens.getNext());
    }
}
